unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, ToolEdit;

type
  TfrmMain = class(TForm)
    DirectoryEdit1: TDirectoryEdit;
    Button1: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    Button2: TButton;
    Label2: TLabel;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure ScanDir(Dir: string; maskfile: string = '*.*'; subdir: boolean = true);
    procedure addlist(Dir: string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

//  
function GetFileCount(Dir: string):integer;
var
  fs: TSearchRec;
begin
  Result := 0;
  if FindFirst(Dir+'\*.*',faAnyFile-faDirectory-faVolumeID, fs) = 0 then
  repeat
    inc(Result);
  until FindNext(fs) <> 0;
  FindClose(fs);
end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  Label1.Caption := ' : ' + IntToStr(GetFileCount(DirectoryEdit1.Text));
end;


procedure TfrmMain.ScanDir(Dir:string; maskfile: string = '*.*'; subdir: boolean = true);
var
  SearchRec:TSearchRec;
begin
  if Dir = '' then exit; //    
  if Dir[length(Dir)] <> '\' then Dir := Dir+'\';  //    
  Application.ProcessMessages;
  if FindFirst(Dir + maskfile, faAnyFile, SearchRec) = 0 then
    repeat
    Application.ProcessMessages;
    if (SearchRec.name = '.') or (SearchRec.name = '..') then
      continue;
      if (SearchRec.Attr and faDirectory) <> 0 then
        begin
          if subdir then
            ScanDir(Dir + SearchRec.name); //  : "Dir+SearchRec.name"
        end
      else
        begin
          addlist(Dir + SearchRec.name); //   
         end;

     if Button3.Tag = 0 then break; // .
     Application.ProcessMessages;
     until
       FindNext(SearchRec) <> 0;

   FindClose(SearchRec);
end;

procedure TfrmMain.addlist(Dir: string);
begin
  ListBox1.Items.Add(Dir);
  Label2.Caption := IntToStr(ListBox1.Items.Count);
end;


procedure TfrmMain.Button2Click(Sender: TObject);
begin
  ListBox1.Clear;
  Button3.Tag := 1;
  ScanDir(DirectoryEdit1.Text, '*.*', false);
end;

procedure TfrmMain.Button3Click(Sender: TObject);
begin
  Button3.Tag := 0;
end;

end.
